<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Vec.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_vec_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Vec.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_vec_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_Vec_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_Vec_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">//#include &quot;RayTracer.hpp&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;math.h&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="class_vec.html">   16</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_vec.html">Vec</a> {</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">   21</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">x</a>;</div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">   23</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">y</a>;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="class_vec.html#a1517109e425feb5925733588631f862c">   25</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_vec.html#a1517109e425feb5925733588631f862c">z</a>;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="class_vec.html#a851e89b0653553745cb01ebf55268d56">   27</a></span>&#160;    <span class="keywordtype">double</span>&amp; <a class="code" href="class_vec.html#a851e89b0653553745cb01ebf55268d56">operator[]</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) { </div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keywordflow">if</span> (i==0)</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;            <span class="keywordflow">return</span> <a class="code" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">x</a>;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i==1)</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;            <span class="keywordflow">return</span> <a class="code" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">y</a>;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keywordflow">else</span> </div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;            <span class="keywordflow">return</span> <a class="code" href="class_vec.html#a1517109e425feb5925733588631f862c">z</a>;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;     }</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">   37</a></span>&#160;    <a class="code" href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">Vec</a>(<span class="keywordtype">double</span> x_=0, <span class="keywordtype">double</span> y_=0, <span class="keywordtype">double</span> z_=0){ x=x_; y=y_; z=z_; }</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="class_vec.html#a436959bd7cacc35bd0ec920ab6c4db10">   40</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vec.html#a436959bd7cacc35bd0ec920ab6c4db10">operator+</a>(<span class="keyword">const</span> <a class="code" href="class_vec.html">Vec</a> &amp;b)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">Vec</a>(x+b.<a class="code" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">x</a>,y+b.<a class="code" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">y</a>,z+b.<a class="code" href="class_vec.html#a1517109e425feb5925733588631f862c">z</a>); }</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="class_vec.html#afd81c5160ec2a2a4ce0e13a95e344d9f">   43</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vec.html#afd81c5160ec2a2a4ce0e13a95e344d9f">operator-</a>(<span class="keyword">const</span> <a class="code" href="class_vec.html">Vec</a> &amp;b)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">Vec</a>(x-b.<a class="code" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">x</a>,y-b.<a class="code" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">y</a>,z-b.<a class="code" href="class_vec.html#a1517109e425feb5925733588631f862c">z</a>); }</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="class_vec.html#a73ad126ecde40cd40d7f8d94a28f1d27">   46</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vec.html#a73ad126ecde40cd40d7f8d94a28f1d27">operator*</a>(<span class="keywordtype">double</span> b)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">Vec</a>(x*b,y*b,z*b); }</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    </div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="class_vec.html#a6f1779ed87ed0b6b1c8d6b30fb6973c7">   49</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vec.html#a6f1779ed87ed0b6b1c8d6b30fb6973c7">operator/</a>(<span class="keywordtype">double</span> b)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">Vec</a>(x/b,y/b,z/b); }</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="class_vec.html#a40f86c7549206f61a8b92c0b0f734b7e">   52</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vec.html#a40f86c7549206f61a8b92c0b0f734b7e">mult</a>(<span class="keyword">const</span> <a class="code" href="class_vec.html">Vec</a> &amp;b)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">Vec</a>(x*b.<a class="code" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">x</a>,y*b.<a class="code" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">y</a>,z*b.<a class="code" href="class_vec.html#a1517109e425feb5925733588631f862c">z</a>); }</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="class_vec.html#a5f9a71c878030b35a8399ea5def98924">   55</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vec.html#a5f9a71c878030b35a8399ea5def98924">div</a>(<span class="keyword">const</span> <a class="code" href="class_vec.html">Vec</a> &amp;b)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">Vec</a>(x/b.<a class="code" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">x</a>,y/b.<a class="code" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">y</a>,z/b.<a class="code" href="class_vec.html#a1517109e425feb5925733588631f862c">z</a>); }</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="class_vec.html#ad565fbb5b8815047fc201f415e2779b2">   58</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a>&amp; <a class="code" href="class_vec.html#ad565fbb5b8815047fc201f415e2779b2">normalize</a>(){ <span class="keywordflow">return</span> *<span class="keyword">this</span> = *<span class="keyword">this</span> * (1/sqrt(x*x+y*y+z*z)); }</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="class_vec.html#ae690197cdfb7a9a0c07bed671263b2bf">   61</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_vec.html#ae690197cdfb7a9a0c07bed671263b2bf">norm</a>(){ <span class="keywordflow">return</span> sqrt(x*x+y*y+z*z); }</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    </div><div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="class_vec.html#aff3033b4827d5ce26ad1652a0c92e4c0">   64</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_vec.html#aff3033b4827d5ce26ad1652a0c92e4c0">dot</a>(<span class="keyword">const</span> <a class="code" href="class_vec.html">Vec</a> &amp;b)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> x*b.<a class="code" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">x</a>+y*b.<a class="code" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">y</a>+z*b.<a class="code" href="class_vec.html#a1517109e425feb5925733588631f862c">z</a>; }</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="class_vec.html#a4671f57d4ff6d2af27703071c95a00bb">   67</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vec.html#a4671f57d4ff6d2af27703071c95a00bb">operator%</a>(<a class="code" href="class_vec.html">Vec</a>&amp;b){<span class="keywordflow">return</span> <a class="code" href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">Vec</a>(y*b.<a class="code" href="class_vec.html#a1517109e425feb5925733588631f862c">z</a>-z*b.<a class="code" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">y</a>,z*b.<a class="code" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">x</a>-x*b.<a class="code" href="class_vec.html#a1517109e425feb5925733588631f862c">z</a>,x*b.<a class="code" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">y</a>-y*b.<a class="code" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">x</a>);}</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    </div><div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="class_vec.html#a6a161e229a763d5918933b60246d49fa">   70</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_vec.html#a6a161e229a763d5918933b60246d49fa">print</a>() {std::cout&lt;&lt;<span class="stringliteral">&quot;Vec(&quot;</span>&lt;&lt;x&lt;&lt;<span class="stringliteral">&quot;, &quot;</span> &lt;&lt;y&lt;&lt;<span class="stringliteral">&quot;, &quot;</span>&lt;&lt;z&lt;&lt;<span class="stringliteral">&quot;) &quot;</span>;}</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;};</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_vec_html_a6f1779ed87ed0b6b1c8d6b30fb6973c7"><div class="ttname"><a href="class_vec.html#a6f1779ed87ed0b6b1c8d6b30fb6973c7">Vec::operator/</a></div><div class="ttdeci">Vec operator/(double b) const</div><div class="ttdoc">Returns the result of performing an element-wise division between this vector and a given scalar...</div><div class="ttdef"><b>Definition:</b> Vec.hpp:49</div></div>
<div class="ttc" id="class_vec_html_a7e01ed5aadbe96e61e9192edf6cb740b"><div class="ttname"><a href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">Vec::y</a></div><div class="ttdeci">double y</div><div class="ttdoc">Second coordinate of this vector. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:23</div></div>
<div class="ttc" id="class_vec_html_a1517109e425feb5925733588631f862c"><div class="ttname"><a href="class_vec.html#a1517109e425feb5925733588631f862c">Vec::z</a></div><div class="ttdeci">double z</div><div class="ttdoc">Third coordinate of this vector. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:25</div></div>
<div class="ttc" id="class_vec_html_a40f86c7549206f61a8b92c0b0f734b7e"><div class="ttname"><a href="class_vec.html#a40f86c7549206f61a8b92c0b0f734b7e">Vec::mult</a></div><div class="ttdeci">Vec mult(const Vec &amp;b) const</div><div class="ttdoc">Returns the result of performing an element-wise multiplication between this vector and another given...</div><div class="ttdef"><b>Definition:</b> Vec.hpp:52</div></div>
<div class="ttc" id="class_vec_html_afd81c5160ec2a2a4ce0e13a95e344d9f"><div class="ttname"><a href="class_vec.html#afd81c5160ec2a2a4ce0e13a95e344d9f">Vec::operator-</a></div><div class="ttdeci">Vec operator-(const Vec &amp;b) const</div><div class="ttdoc">Returns the result of subtracting a given vector to this vector. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:43</div></div>
<div class="ttc" id="class_vec_html_aff3033b4827d5ce26ad1652a0c92e4c0"><div class="ttname"><a href="class_vec.html#aff3033b4827d5ce26ad1652a0c92e4c0">Vec::dot</a></div><div class="ttdeci">double dot(const Vec &amp;b) const</div><div class="ttdoc">Returns the dot-product between this vector and another given vector. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:64</div></div>
<div class="ttc" id="class_vec_html_a5f9a71c878030b35a8399ea5def98924"><div class="ttname"><a href="class_vec.html#a5f9a71c878030b35a8399ea5def98924">Vec::div</a></div><div class="ttdeci">Vec div(const Vec &amp;b) const</div><div class="ttdoc">Returns the result of performing an element-wise division between this vector and another given vecto...</div><div class="ttdef"><b>Definition:</b> Vec.hpp:55</div></div>
<div class="ttc" id="class_vec_html_a4671f57d4ff6d2af27703071c95a00bb"><div class="ttname"><a href="class_vec.html#a4671f57d4ff6d2af27703071c95a00bb">Vec::operator%</a></div><div class="ttdeci">Vec operator%(Vec &amp;b)</div><div class="ttdoc">Returns the cross-product between this vector and another given vector. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:67</div></div>
<div class="ttc" id="class_vec_html_a6b06c403da715c182792139c41fb4e1a"><div class="ttname"><a href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">Vec::x</a></div><div class="ttdeci">double x</div><div class="ttdoc">First coordinate of this vector. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:21</div></div>
<div class="ttc" id="class_vec_html_a73ad126ecde40cd40d7f8d94a28f1d27"><div class="ttname"><a href="class_vec.html#a73ad126ecde40cd40d7f8d94a28f1d27">Vec::operator*</a></div><div class="ttdeci">Vec operator*(double b) const</div><div class="ttdoc">Returns the result of performing an element-wise multiplication between this vector and a scalar...</div><div class="ttdef"><b>Definition:</b> Vec.hpp:46</div></div>
<div class="ttc" id="class_vec_html_a6a161e229a763d5918933b60246d49fa"><div class="ttname"><a href="class_vec.html#a6a161e229a763d5918933b60246d49fa">Vec::print</a></div><div class="ttdeci">void print()</div><div class="ttdoc">Sends to the std::out information regarding this vector. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:70</div></div>
<div class="ttc" id="class_vec_html_a851e89b0653553745cb01ebf55268d56"><div class="ttname"><a href="class_vec.html#a851e89b0653553745cb01ebf55268d56">Vec::operator[]</a></div><div class="ttdeci">double &amp; operator[](const unsigned int i)</div><div class="ttdef"><b>Definition:</b> Vec.hpp:27</div></div>
<div class="ttc" id="class_vec_html_ad565fbb5b8815047fc201f415e2779b2"><div class="ttname"><a href="class_vec.html#ad565fbb5b8815047fc201f415e2779b2">Vec::normalize</a></div><div class="ttdeci">Vec &amp; normalize()</div><div class="ttdoc">Returns a unit-length scaled version of this vector. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:58</div></div>
<div class="ttc" id="class_vec_html_ae690197cdfb7a9a0c07bed671263b2bf"><div class="ttname"><a href="class_vec.html#ae690197cdfb7a9a0c07bed671263b2bf">Vec::norm</a></div><div class="ttdeci">double norm()</div><div class="ttdoc">Returns the norm of this vector. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:61</div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="class_vec_html_a436959bd7cacc35bd0ec920ab6c4db10"><div class="ttname"><a href="class_vec.html#a436959bd7cacc35bd0ec920ab6c4db10">Vec::operator+</a></div><div class="ttdeci">Vec operator+(const Vec &amp;b) const</div><div class="ttdoc">Returns the result of adding a given vector to this vector. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:40</div></div>
<div class="ttc" id="class_vec_html_a2e56ebfd280de14db0d12c906374d0a4"><div class="ttname"><a href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">Vec::Vec</a></div><div class="ttdeci">Vec(double x_=0, double y_=0, double z_=0)</div><div class="ttdoc">A Vec constructor. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:37</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_vec_8hpp.html">Vec.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
